/* server for receiving commands from IDC Client */ 
var listenSocket;
/* port of ifc server*/
var remoteIdcPort = 8226;
/* local server */ 
var localServerPort = 8231;

/* disable proxy */
function ProxyDisable() {
  
    var sett = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch);

  	sett.setIntPref("network.proxy.type", 0);
  	sett.setCharPref("network.proxy.http", '');
  	sett.setIntPref("network.proxy.http_port", 0);
  	
  	sett.setCharPref("network.proxy.ssl", ''); 
  	sett.setCharPref("network.proxy.ftp", ''); 
  	sett.setIntPref("network.proxy.ssl_port", 0); 
  	sett.setIntPref("network.proxy.ftp_port", 0); 
}

/*set proxy */
function ProxySet(proxy,port)
{
      var sett = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch);
                        
      sett.setIntPref("network.proxy.type", 1);
      sett.setCharPref("network.proxy.http", proxy);
      sett.setIntPref("network.proxy.http_port", port);
      
      
      sett.setCharPref("network.proxy.ssl", proxy); 
      sett.setCharPref("network.proxy.ftp", proxy); 
      sett.setIntPref("network.proxy.ssl_port", port); 
      sett.setIntPref("network.proxy.ftp_port", port); 
  
}

/* command for proxy change received */
function ProxyChange(command)
{          
  
  var port = 0;
  var proxy;
    /* format IdcCommand:localhost:8080 */
      
  var data  = command.split(":");
   
  if(data[0] == "IdcCommand") // have to start with string IdcCommand
  { 
      // port
      port = data[2];
      proxy = data[1]; // proxy addr
      
      // set only if not null
      if ((port != 0) && (port != null && (proxy != null)))
      {
         
        ProxySet(proxy,port);
         
      }
      else// port 0 means disable proxy
        ProxyDisable();
      
  }  

}


// stream for IDC client notice
 var IdcOutstream = null;
 var IdcInputStream = null;
 var connection = null;  
 
 // notice IDC client
function IdcStartSockets(port){
   try
   {
       var netTransp =  null;     
       var stream = null;
       var netTransp  = null;
          
       IdcOutstream = null;
       IdcInputStream = null;       
       connection = null;             
      
        netTransp =  Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);

        if(netTransp != null)
            connection = netTransp.createTransport(null, 0, "127.0.0.1",port, null);
        if(connection != null)  
        {            
            // outstream
            IdcOutstream = connection.openOutputStream(0,0,0);                        
        }   
                      
        if(connection != null)
        {
            // instream
            stream = connection.openInputStream(0, 0, 0);
            IdcInputstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
            IdcInputstream.init(stream);                                      
        }
       
    }
    catch(e){
     
    }
 }
 // slose IDC client notice service
 function informSocketIdcClose(){
   try
   {   
        if(IdcInputStream != null)
            IdcInputStream.close();
        if(IdcOutstream != null)
            IdcOutstream.close();
        if(connection != null)
           connection.close(0);
            
        IdcInputStream = null;
        IdcOutstream = null;
        connection = null; 
        
    }
    catch(e)
    {
        
    }
};



function delayedRead()
{
   // alert("reada");
   // have wee received some reply from the server ? 
    var avail = IdcInputstream.available();         
                        
    if(avail > 8)// yes
    {                    
        var inputText = IdcInputstream.read(avail);
                        // read and chceck reply                 
       if(inputText == "IdcServerOK")
       {
    //      alert("Server Ok");   // reply ok        
          return;
       } 
    }
      
   if(remoteIdcPort < 8231) // bad or no reply try another port
   {
    // close informing sockets
     informSocketIdcClose();     
     
     remoteIdcPort++;     // start again with different port
     IdcStartSockets(remoteIdcPort);         
     
     var data = "IdcFFextStart"// send new message to IDC client
     IdcOutstream.write(data,data.length);
   
     //alert("retry");
     window.setTimeout(delayedRead, 100); // check reply after 100ms
     
   }
   
}

function listener_start(port)
{
    var serverListener =
    {        
        onSocketAccepted : function(socket, transport)
        {
            try
            {
                var stream = transport.openInputStream(0,0,0);
                var instream = Components.classes["@mozilla.org/scriptableinputstream;1"]
                                    .createInstance(Components.interfaces.nsIScriptableInputStream);                                     
                var serverDataListener =
                {
                    data : "",
                    onStartRequest: function(request, context){},
                    onStopRequest: function(request, context, status)
                    {   
                        instream.close();
                        
                        ProxyChange(this.data);
                    },
                    
                    /* data ready to read */
                    onDataAvailable: function(request, context, inputStream, offset, count)
                    {
                        instream.init(inputStream);                    
                        this.data += instream.read(count);
                    },
                    
                };

                var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].
                                createInstance(Components.interfaces.nsIInputStreamPump);
                pump.init(stream, -1, -1, 0, 0, false);
                pump.asyncRead(serverDataListener,null);        
                
            }
            catch(e) 
            {
              
            }
    },

    onStopListening : function(socket, status) {}
    };

    try 
    {
        
        listenSocket = Components.classes["@mozilla.org/network/server-socket;1"]
                         .createInstance(Components.interfaces.nsIServerSocket);
    
      
        listenSocket.init(port,true,-1);
      
        
        listenSocket.asyncListen(serverListener);
    }
    catch(e2)
    {
     //   alert(e2);
    }
}

function stopLocalServer()
{
   // alert("close");
  if(listenSocket)
  {
      listenSocket.close();
  }
}


// Constants for convience
if (typeof(Cc) == "undefined")
  var Cc = Components.classes;
  
if (typeof(Ci) == "undefined")
  var Ci = Components.interfaces;  
  

/* call after on window load event */
function IdcExtOnLoad()
{            
   ProxyDisable();
    // listener server started
   listener_start(localServerPort);
    
     //inicialize local socket used for noticing IDC client 
   IdcStartSockets(remoteIdcPort);
    
    // send notice to IDC
    var data = "IdcFFextStart"
    IdcOutstream.write(data,data.length);
   
    // check reply after 100ms
    window.setTimeout(delayedRead, 100);
    
}



